<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BerichtObject StructType
 * @subpackage Structs
 */
class BerichtObject extends AbstractStructBase
{
    /**
     * The datum_bijgewerkt
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $datum_bijgewerkt;
    /**
     * The onroerende_zaak
     * @var \StructType\OnroerendeZaak
     */
    public $onroerende_zaak;
    /**
     * The rechten_lijst
     * @var \StructType\RechtenLijst
     */
    public $rechten_lijst;
    /**
     * The personen
     * @var \ArrayType\PersoonArray
     */
    public $personen;
    /**
     * The stukken
     * @var \ArrayType\StukArray
     */
    public $stukken;
    /**
     * The gemeentestukken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GemeenteStukArray
     */
    public $gemeentestukken;
    /**
     * The document
     * @var string
     */
    public $document;
    /**
     * Constructor method for BerichtObject
     * @uses BerichtObject::setDatum_bijgewerkt()
     * @uses BerichtObject::setOnroerende_zaak()
     * @uses BerichtObject::setRechten_lijst()
     * @uses BerichtObject::setPersonen()
     * @uses BerichtObject::setStukken()
     * @uses BerichtObject::setGemeentestukken()
     * @uses BerichtObject::setDocument()
     * @param string $datum_bijgewerkt
     * @param \StructType\OnroerendeZaak $onroerende_zaak
     * @param \StructType\RechtenLijst $rechten_lijst
     * @param \ArrayType\PersoonArray $personen
     * @param \ArrayType\StukArray $stukken
     * @param \ArrayType\GemeenteStukArray $gemeentestukken
     * @param string $document
     */
    public function __construct($datum_bijgewerkt = null, \StructType\OnroerendeZaak $onroerende_zaak = null, \StructType\RechtenLijst $rechten_lijst = null, \ArrayType\PersoonArray $personen = null, \ArrayType\StukArray $stukken = null, \ArrayType\GemeenteStukArray $gemeentestukken = null, $document = null)
    {
        $this
            ->setDatum_bijgewerkt($datum_bijgewerkt)
            ->setOnroerende_zaak($onroerende_zaak)
            ->setRechten_lijst($rechten_lijst)
            ->setPersonen($personen)
            ->setStukken($stukken)
            ->setGemeentestukken($gemeentestukken)
            ->setDocument($document);
    }
    /**
     * Get datum_bijgewerkt value
     * @return string|null
     */
    public function getDatum_bijgewerkt()
    {
        return $this->datum_bijgewerkt;
    }
    /**
     * Set datum_bijgewerkt value
     * @param string $datum_bijgewerkt
     * @return \StructType\BerichtObject
     */
    public function setDatum_bijgewerkt($datum_bijgewerkt = null)
    {
        // validation for constraint: string
        if (!is_null($datum_bijgewerkt) && !is_string($datum_bijgewerkt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datum_bijgewerkt, true), gettype($datum_bijgewerkt)), __LINE__);
        }
        $this->datum_bijgewerkt = $datum_bijgewerkt;
        return $this;
    }
    /**
     * Get onroerende_zaak value
     * @return \StructType\OnroerendeZaak|null
     */
    public function getOnroerende_zaak()
    {
        return $this->onroerende_zaak;
    }
    /**
     * Set onroerende_zaak value
     * @param \StructType\OnroerendeZaak $onroerende_zaak
     * @return \StructType\BerichtObject
     */
    public function setOnroerende_zaak(\StructType\OnroerendeZaak $onroerende_zaak = null)
    {
        $this->onroerende_zaak = $onroerende_zaak;
        return $this;
    }
    /**
     * Get rechten_lijst value
     * @return \StructType\RechtenLijst|null
     */
    public function getRechten_lijst()
    {
        return $this->rechten_lijst;
    }
    /**
     * Set rechten_lijst value
     * @param \StructType\RechtenLijst $rechten_lijst
     * @return \StructType\BerichtObject
     */
    public function setRechten_lijst(\StructType\RechtenLijst $rechten_lijst = null)
    {
        $this->rechten_lijst = $rechten_lijst;
        return $this;
    }
    /**
     * Get personen value
     * @return \ArrayType\PersoonArray|null
     */
    public function getPersonen()
    {
        return $this->personen;
    }
    /**
     * Set personen value
     * @param \ArrayType\PersoonArray $personen
     * @return \StructType\BerichtObject
     */
    public function setPersonen(\ArrayType\PersoonArray $personen = null)
    {
        $this->personen = $personen;
        return $this;
    }
    /**
     * Get stukken value
     * @return \ArrayType\StukArray|null
     */
    public function getStukken()
    {
        return $this->stukken;
    }
    /**
     * Set stukken value
     * @param \ArrayType\StukArray $stukken
     * @return \StructType\BerichtObject
     */
    public function setStukken(\ArrayType\StukArray $stukken = null)
    {
        $this->stukken = $stukken;
        return $this;
    }
    /**
     * Get gemeentestukken value
     * @return \ArrayType\GemeenteStukArray|null
     */
    public function getGemeentestukken()
    {
        return $this->gemeentestukken;
    }
    /**
     * Set gemeentestukken value
     * @param \ArrayType\GemeenteStukArray $gemeentestukken
     * @return \StructType\BerichtObject
     */
    public function setGemeentestukken(\ArrayType\GemeenteStukArray $gemeentestukken = null)
    {
        $this->gemeentestukken = $gemeentestukken;
        return $this;
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\BerichtObject
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
}
