<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarRDWCarDataPrice StructType
 * @subpackage Structs
 */
class CarRDWCarDataPrice extends AbstractStructBase
{
    /**
     * The basic_car_data
     * @var \StructType\CarV3
     */
    public $basic_car_data;
    /**
     * The environment_data
     * @var \StructType\CarEnvironment
     */
    public $environment_data;
    /**
     * The status_data
     * @var \StructType\CarStatus
     */
    public $status_data;
    /**
     * The power
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $power;
    /**
     * The fuel_types
     * @var \ArrayType\StringArray
     */
    public $fuel_types;
    /**
     * The top_speed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $top_speed;
    /**
     * The catalog_price
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $catalog_price;
    /**
     * The bpm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $bpm;
    /**
     * The bodies
     * @var \ArrayType\CarBodyArray
     */
    public $bodies;
    /**
     * Constructor method for CarRDWCarDataPrice
     * @uses CarRDWCarDataPrice::setBasic_car_data()
     * @uses CarRDWCarDataPrice::setEnvironment_data()
     * @uses CarRDWCarDataPrice::setStatus_data()
     * @uses CarRDWCarDataPrice::setPower()
     * @uses CarRDWCarDataPrice::setFuel_types()
     * @uses CarRDWCarDataPrice::setTop_speed()
     * @uses CarRDWCarDataPrice::setCatalog_price()
     * @uses CarRDWCarDataPrice::setBpm()
     * @uses CarRDWCarDataPrice::setBodies()
     * @param \StructType\CarV3 $basic_car_data
     * @param \StructType\CarEnvironment $environment_data
     * @param \StructType\CarStatus $status_data
     * @param float $power
     * @param \ArrayType\StringArray $fuel_types
     * @param int $top_speed
     * @param int $catalog_price
     * @param int $bpm
     * @param \ArrayType\CarBodyArray $bodies
     */
    public function __construct(\StructType\CarV3 $basic_car_data = null, \StructType\CarEnvironment $environment_data = null, \StructType\CarStatus $status_data = null, $power = null, \ArrayType\StringArray $fuel_types = null, $top_speed = null, $catalog_price = null, $bpm = null, \ArrayType\CarBodyArray $bodies = null)
    {
        $this
            ->setBasic_car_data($basic_car_data)
            ->setEnvironment_data($environment_data)
            ->setStatus_data($status_data)
            ->setPower($power)
            ->setFuel_types($fuel_types)
            ->setTop_speed($top_speed)
            ->setCatalog_price($catalog_price)
            ->setBpm($bpm)
            ->setBodies($bodies);
    }
    /**
     * Get basic_car_data value
     * @return \StructType\CarV3|null
     */
    public function getBasic_car_data()
    {
        return $this->basic_car_data;
    }
    /**
     * Set basic_car_data value
     * @param \StructType\CarV3 $basic_car_data
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setBasic_car_data(\StructType\CarV3 $basic_car_data = null)
    {
        $this->basic_car_data = $basic_car_data;
        return $this;
    }
    /**
     * Get environment_data value
     * @return \StructType\CarEnvironment|null
     */
    public function getEnvironment_data()
    {
        return $this->environment_data;
    }
    /**
     * Set environment_data value
     * @param \StructType\CarEnvironment $environment_data
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setEnvironment_data(\StructType\CarEnvironment $environment_data = null)
    {
        $this->environment_data = $environment_data;
        return $this;
    }
    /**
     * Get status_data value
     * @return \StructType\CarStatus|null
     */
    public function getStatus_data()
    {
        return $this->status_data;
    }
    /**
     * Set status_data value
     * @param \StructType\CarStatus $status_data
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setStatus_data(\StructType\CarStatus $status_data = null)
    {
        $this->status_data = $status_data;
        return $this;
    }
    /**
     * Get power value
     * @return float|null
     */
    public function getPower()
    {
        return $this->power;
    }
    /**
     * Set power value
     * @param float $power
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setPower($power = null)
    {
        // validation for constraint: float
        if (!is_null($power) && !(is_float($power) || is_numeric($power))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($power, true), gettype($power)), __LINE__);
        }
        $this->power = $power;
        return $this;
    }
    /**
     * Get fuel_types value
     * @return \ArrayType\StringArray|null
     */
    public function getFuel_types()
    {
        return $this->fuel_types;
    }
    /**
     * Set fuel_types value
     * @param \ArrayType\StringArray $fuel_types
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setFuel_types(\ArrayType\StringArray $fuel_types = null)
    {
        $this->fuel_types = $fuel_types;
        return $this;
    }
    /**
     * Get top_speed value
     * @return int|null
     */
    public function getTop_speed()
    {
        return $this->top_speed;
    }
    /**
     * Set top_speed value
     * @param int $top_speed
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setTop_speed($top_speed = null)
    {
        // validation for constraint: int
        if (!is_null($top_speed) && !(is_int($top_speed) || ctype_digit($top_speed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($top_speed, true), gettype($top_speed)), __LINE__);
        }
        $this->top_speed = $top_speed;
        return $this;
    }
    /**
     * Get catalog_price value
     * @return int|null
     */
    public function getCatalog_price()
    {
        return $this->catalog_price;
    }
    /**
     * Set catalog_price value
     * @param int $catalog_price
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setCatalog_price($catalog_price = null)
    {
        // validation for constraint: int
        if (!is_null($catalog_price) && !(is_int($catalog_price) || ctype_digit($catalog_price))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($catalog_price, true), gettype($catalog_price)), __LINE__);
        }
        $this->catalog_price = $catalog_price;
        return $this;
    }
    /**
     * Get bpm value
     * @return int|null
     */
    public function getBpm()
    {
        return $this->bpm;
    }
    /**
     * Set bpm value
     * @param int $bpm
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setBpm($bpm = null)
    {
        // validation for constraint: int
        if (!is_null($bpm) && !(is_int($bpm) || ctype_digit($bpm))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bpm, true), gettype($bpm)), __LINE__);
        }
        $this->bpm = $bpm;
        return $this;
    }
    /**
     * Get bodies value
     * @return \ArrayType\CarBodyArray|null
     */
    public function getBodies()
    {
        return $this->bodies;
    }
    /**
     * Set bodies value
     * @param \ArrayType\CarBodyArray $bodies
     * @return \StructType\CarRDWCarDataPrice
     */
    public function setBodies(\ArrayType\CarBodyArray $bodies = null)
    {
        $this->bodies = $bodies;
        return $this;
    }
}
