<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyRatiosV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyRatiosV2 extends AbstractStructBase
{
    /**
     * The creditor_days
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $creditor_days;
    /**
     * The current_debt_ratio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $current_debt_ratio;
    /**
     * The current_ratio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $current_ratio;
    /**
     * The debtor_days
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $debtor_days;
    /**
     * The equity_in_percentage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $equity_in_percentage;
    /**
     * The gearing
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $gearing;
    /**
     * The liquidity_ratio_or_acid_test
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $liquidity_ratio_or_acid_test;
    /**
     * The pre_tax_profit_margin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $pre_tax_profit_margin;
    /**
     * The return_on_capital_employed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $return_on_capital_employed;
    /**
     * The return_on_net_assets_employed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $return_on_net_assets_employed;
    /**
     * The return_on_total_assets_employed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $return_on_total_assets_employed;
    /**
     * The sales_or_net_working_capital
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $sales_or_net_working_capital;
    /**
     * The stock_turnover_ratio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $stock_turnover_ratio;
    /**
     * The total_debt_ratio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $total_debt_ratio;
    /**
     * Constructor method for CreditsafeCompanyRatiosV2
     * @uses CreditsafeCompanyRatiosV2::setCreditor_days()
     * @uses CreditsafeCompanyRatiosV2::setCurrent_debt_ratio()
     * @uses CreditsafeCompanyRatiosV2::setCurrent_ratio()
     * @uses CreditsafeCompanyRatiosV2::setDebtor_days()
     * @uses CreditsafeCompanyRatiosV2::setEquity_in_percentage()
     * @uses CreditsafeCompanyRatiosV2::setGearing()
     * @uses CreditsafeCompanyRatiosV2::setLiquidity_ratio_or_acid_test()
     * @uses CreditsafeCompanyRatiosV2::setPre_tax_profit_margin()
     * @uses CreditsafeCompanyRatiosV2::setReturn_on_capital_employed()
     * @uses CreditsafeCompanyRatiosV2::setReturn_on_net_assets_employed()
     * @uses CreditsafeCompanyRatiosV2::setReturn_on_total_assets_employed()
     * @uses CreditsafeCompanyRatiosV2::setSales_or_net_working_capital()
     * @uses CreditsafeCompanyRatiosV2::setStock_turnover_ratio()
     * @uses CreditsafeCompanyRatiosV2::setTotal_debt_ratio()
     * @param float $creditor_days
     * @param float $current_debt_ratio
     * @param float $current_ratio
     * @param float $debtor_days
     * @param float $equity_in_percentage
     * @param float $gearing
     * @param float $liquidity_ratio_or_acid_test
     * @param float $pre_tax_profit_margin
     * @param float $return_on_capital_employed
     * @param float $return_on_net_assets_employed
     * @param float $return_on_total_assets_employed
     * @param float $sales_or_net_working_capital
     * @param float $stock_turnover_ratio
     * @param float $total_debt_ratio
     */
    public function __construct($creditor_days = null, $current_debt_ratio = null, $current_ratio = null, $debtor_days = null, $equity_in_percentage = null, $gearing = null, $liquidity_ratio_or_acid_test = null, $pre_tax_profit_margin = null, $return_on_capital_employed = null, $return_on_net_assets_employed = null, $return_on_total_assets_employed = null, $sales_or_net_working_capital = null, $stock_turnover_ratio = null, $total_debt_ratio = null)
    {
        $this
            ->setCreditor_days($creditor_days)
            ->setCurrent_debt_ratio($current_debt_ratio)
            ->setCurrent_ratio($current_ratio)
            ->setDebtor_days($debtor_days)
            ->setEquity_in_percentage($equity_in_percentage)
            ->setGearing($gearing)
            ->setLiquidity_ratio_or_acid_test($liquidity_ratio_or_acid_test)
            ->setPre_tax_profit_margin($pre_tax_profit_margin)
            ->setReturn_on_capital_employed($return_on_capital_employed)
            ->setReturn_on_net_assets_employed($return_on_net_assets_employed)
            ->setReturn_on_total_assets_employed($return_on_total_assets_employed)
            ->setSales_or_net_working_capital($sales_or_net_working_capital)
            ->setStock_turnover_ratio($stock_turnover_ratio)
            ->setTotal_debt_ratio($total_debt_ratio);
    }
    /**
     * Get creditor_days value
     * @return float|null
     */
    public function getCreditor_days()
    {
        return $this->creditor_days;
    }
    /**
     * Set creditor_days value
     * @param float $creditor_days
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setCreditor_days($creditor_days = null)
    {
        // validation for constraint: float
        if (!is_null($creditor_days) && !(is_float($creditor_days) || is_numeric($creditor_days))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($creditor_days, true), gettype($creditor_days)), __LINE__);
        }
        $this->creditor_days = $creditor_days;
        return $this;
    }
    /**
     * Get current_debt_ratio value
     * @return float|null
     */
    public function getCurrent_debt_ratio()
    {
        return $this->current_debt_ratio;
    }
    /**
     * Set current_debt_ratio value
     * @param float $current_debt_ratio
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setCurrent_debt_ratio($current_debt_ratio = null)
    {
        // validation for constraint: float
        if (!is_null($current_debt_ratio) && !(is_float($current_debt_ratio) || is_numeric($current_debt_ratio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($current_debt_ratio, true), gettype($current_debt_ratio)), __LINE__);
        }
        $this->current_debt_ratio = $current_debt_ratio;
        return $this;
    }
    /**
     * Get current_ratio value
     * @return float|null
     */
    public function getCurrent_ratio()
    {
        return $this->current_ratio;
    }
    /**
     * Set current_ratio value
     * @param float $current_ratio
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setCurrent_ratio($current_ratio = null)
    {
        // validation for constraint: float
        if (!is_null($current_ratio) && !(is_float($current_ratio) || is_numeric($current_ratio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($current_ratio, true), gettype($current_ratio)), __LINE__);
        }
        $this->current_ratio = $current_ratio;
        return $this;
    }
    /**
     * Get debtor_days value
     * @return float|null
     */
    public function getDebtor_days()
    {
        return $this->debtor_days;
    }
    /**
     * Set debtor_days value
     * @param float $debtor_days
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setDebtor_days($debtor_days = null)
    {
        // validation for constraint: float
        if (!is_null($debtor_days) && !(is_float($debtor_days) || is_numeric($debtor_days))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($debtor_days, true), gettype($debtor_days)), __LINE__);
        }
        $this->debtor_days = $debtor_days;
        return $this;
    }
    /**
     * Get equity_in_percentage value
     * @return float|null
     */
    public function getEquity_in_percentage()
    {
        return $this->equity_in_percentage;
    }
    /**
     * Set equity_in_percentage value
     * @param float $equity_in_percentage
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setEquity_in_percentage($equity_in_percentage = null)
    {
        // validation for constraint: float
        if (!is_null($equity_in_percentage) && !(is_float($equity_in_percentage) || is_numeric($equity_in_percentage))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($equity_in_percentage, true), gettype($equity_in_percentage)), __LINE__);
        }
        $this->equity_in_percentage = $equity_in_percentage;
        return $this;
    }
    /**
     * Get gearing value
     * @return float|null
     */
    public function getGearing()
    {
        return $this->gearing;
    }
    /**
     * Set gearing value
     * @param float $gearing
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setGearing($gearing = null)
    {
        // validation for constraint: float
        if (!is_null($gearing) && !(is_float($gearing) || is_numeric($gearing))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gearing, true), gettype($gearing)), __LINE__);
        }
        $this->gearing = $gearing;
        return $this;
    }
    /**
     * Get liquidity_ratio_or_acid_test value
     * @return float|null
     */
    public function getLiquidity_ratio_or_acid_test()
    {
        return $this->liquidity_ratio_or_acid_test;
    }
    /**
     * Set liquidity_ratio_or_acid_test value
     * @param float $liquidity_ratio_or_acid_test
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setLiquidity_ratio_or_acid_test($liquidity_ratio_or_acid_test = null)
    {
        // validation for constraint: float
        if (!is_null($liquidity_ratio_or_acid_test) && !(is_float($liquidity_ratio_or_acid_test) || is_numeric($liquidity_ratio_or_acid_test))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($liquidity_ratio_or_acid_test, true), gettype($liquidity_ratio_or_acid_test)), __LINE__);
        }
        $this->liquidity_ratio_or_acid_test = $liquidity_ratio_or_acid_test;
        return $this;
    }
    /**
     * Get pre_tax_profit_margin value
     * @return float|null
     */
    public function getPre_tax_profit_margin()
    {
        return $this->pre_tax_profit_margin;
    }
    /**
     * Set pre_tax_profit_margin value
     * @param float $pre_tax_profit_margin
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setPre_tax_profit_margin($pre_tax_profit_margin = null)
    {
        // validation for constraint: float
        if (!is_null($pre_tax_profit_margin) && !(is_float($pre_tax_profit_margin) || is_numeric($pre_tax_profit_margin))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pre_tax_profit_margin, true), gettype($pre_tax_profit_margin)), __LINE__);
        }
        $this->pre_tax_profit_margin = $pre_tax_profit_margin;
        return $this;
    }
    /**
     * Get return_on_capital_employed value
     * @return float|null
     */
    public function getReturn_on_capital_employed()
    {
        return $this->return_on_capital_employed;
    }
    /**
     * Set return_on_capital_employed value
     * @param float $return_on_capital_employed
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setReturn_on_capital_employed($return_on_capital_employed = null)
    {
        // validation for constraint: float
        if (!is_null($return_on_capital_employed) && !(is_float($return_on_capital_employed) || is_numeric($return_on_capital_employed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($return_on_capital_employed, true), gettype($return_on_capital_employed)), __LINE__);
        }
        $this->return_on_capital_employed = $return_on_capital_employed;
        return $this;
    }
    /**
     * Get return_on_net_assets_employed value
     * @return float|null
     */
    public function getReturn_on_net_assets_employed()
    {
        return $this->return_on_net_assets_employed;
    }
    /**
     * Set return_on_net_assets_employed value
     * @param float $return_on_net_assets_employed
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setReturn_on_net_assets_employed($return_on_net_assets_employed = null)
    {
        // validation for constraint: float
        if (!is_null($return_on_net_assets_employed) && !(is_float($return_on_net_assets_employed) || is_numeric($return_on_net_assets_employed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($return_on_net_assets_employed, true), gettype($return_on_net_assets_employed)), __LINE__);
        }
        $this->return_on_net_assets_employed = $return_on_net_assets_employed;
        return $this;
    }
    /**
     * Get return_on_total_assets_employed value
     * @return float|null
     */
    public function getReturn_on_total_assets_employed()
    {
        return $this->return_on_total_assets_employed;
    }
    /**
     * Set return_on_total_assets_employed value
     * @param float $return_on_total_assets_employed
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setReturn_on_total_assets_employed($return_on_total_assets_employed = null)
    {
        // validation for constraint: float
        if (!is_null($return_on_total_assets_employed) && !(is_float($return_on_total_assets_employed) || is_numeric($return_on_total_assets_employed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($return_on_total_assets_employed, true), gettype($return_on_total_assets_employed)), __LINE__);
        }
        $this->return_on_total_assets_employed = $return_on_total_assets_employed;
        return $this;
    }
    /**
     * Get sales_or_net_working_capital value
     * @return float|null
     */
    public function getSales_or_net_working_capital()
    {
        return $this->sales_or_net_working_capital;
    }
    /**
     * Set sales_or_net_working_capital value
     * @param float $sales_or_net_working_capital
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setSales_or_net_working_capital($sales_or_net_working_capital = null)
    {
        // validation for constraint: float
        if (!is_null($sales_or_net_working_capital) && !(is_float($sales_or_net_working_capital) || is_numeric($sales_or_net_working_capital))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sales_or_net_working_capital, true), gettype($sales_or_net_working_capital)), __LINE__);
        }
        $this->sales_or_net_working_capital = $sales_or_net_working_capital;
        return $this;
    }
    /**
     * Get stock_turnover_ratio value
     * @return float|null
     */
    public function getStock_turnover_ratio()
    {
        return $this->stock_turnover_ratio;
    }
    /**
     * Set stock_turnover_ratio value
     * @param float $stock_turnover_ratio
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setStock_turnover_ratio($stock_turnover_ratio = null)
    {
        // validation for constraint: float
        if (!is_null($stock_turnover_ratio) && !(is_float($stock_turnover_ratio) || is_numeric($stock_turnover_ratio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stock_turnover_ratio, true), gettype($stock_turnover_ratio)), __LINE__);
        }
        $this->stock_turnover_ratio = $stock_turnover_ratio;
        return $this;
    }
    /**
     * Get total_debt_ratio value
     * @return float|null
     */
    public function getTotal_debt_ratio()
    {
        return $this->total_debt_ratio;
    }
    /**
     * Set total_debt_ratio value
     * @param float $total_debt_ratio
     * @return \StructType\CreditsafeCompanyRatiosV2
     */
    public function setTotal_debt_ratio($total_debt_ratio = null)
    {
        // validation for constraint: float
        if (!is_null($total_debt_ratio) && !(is_float($total_debt_ratio) || is_numeric($total_debt_ratio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($total_debt_ratio, true), gettype($total_debt_ratio)), __LINE__);
        }
        $this->total_debt_ratio = $total_debt_ratio;
        return $this;
    }
}
