<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeSearchCriteriaParam StructType
 * @subpackage Structs
 */
class CreditsafeSearchCriteriaParam extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $name;
    /**
     * The is_required
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var bool
     */
    public $is_required;
    /**
     * The min_length
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $min_length;
    /**
     * The max_length
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $max_length;
    /**
     * The validation_regexp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $validation_regexp;
    /**
     * The allowed_values
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $allowed_values;
    /**
     * Constructor method for CreditsafeSearchCriteriaParam
     * @uses CreditsafeSearchCriteriaParam::setName()
     * @uses CreditsafeSearchCriteriaParam::setIs_required()
     * @uses CreditsafeSearchCriteriaParam::setMin_length()
     * @uses CreditsafeSearchCriteriaParam::setMax_length()
     * @uses CreditsafeSearchCriteriaParam::setValidation_regexp()
     * @uses CreditsafeSearchCriteriaParam::setAllowed_values()
     * @param string $name
     * @param bool $is_required
     * @param int $min_length
     * @param int $max_length
     * @param string $validation_regexp
     * @param \ArrayType\StringArray $allowed_values
     */
    public function __construct($name = null, $is_required = null, $min_length = null, $max_length = null, $validation_regexp = null, \ArrayType\StringArray $allowed_values = null)
    {
        $this
            ->setName($name)
            ->setIs_required($is_required)
            ->setMin_length($min_length)
            ->setMax_length($max_length)
            ->setValidation_regexp($validation_regexp)
            ->setAllowed_values($allowed_values);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get is_required value
     * @return bool
     */
    public function getIs_required()
    {
        return $this->is_required;
    }
    /**
     * Set is_required value
     * @param bool $is_required
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setIs_required($is_required = null)
    {
        // validation for constraint: boolean
        if (!is_null($is_required) && !is_bool($is_required)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($is_required, true), gettype($is_required)), __LINE__);
        }
        $this->is_required = $is_required;
        return $this;
    }
    /**
     * Get min_length value
     * @return int|null
     */
    public function getMin_length()
    {
        return $this->min_length;
    }
    /**
     * Set min_length value
     * @param int $min_length
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setMin_length($min_length = null)
    {
        // validation for constraint: int
        if (!is_null($min_length) && !(is_int($min_length) || ctype_digit($min_length))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($min_length, true), gettype($min_length)), __LINE__);
        }
        $this->min_length = $min_length;
        return $this;
    }
    /**
     * Get max_length value
     * @return int|null
     */
    public function getMax_length()
    {
        return $this->max_length;
    }
    /**
     * Set max_length value
     * @param int $max_length
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setMax_length($max_length = null)
    {
        // validation for constraint: int
        if (!is_null($max_length) && !(is_int($max_length) || ctype_digit($max_length))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($max_length, true), gettype($max_length)), __LINE__);
        }
        $this->max_length = $max_length;
        return $this;
    }
    /**
     * Get validation_regexp value
     * @return string|null
     */
    public function getValidation_regexp()
    {
        return $this->validation_regexp;
    }
    /**
     * Set validation_regexp value
     * @param string $validation_regexp
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setValidation_regexp($validation_regexp = null)
    {
        // validation for constraint: string
        if (!is_null($validation_regexp) && !is_string($validation_regexp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($validation_regexp, true), gettype($validation_regexp)), __LINE__);
        }
        $this->validation_regexp = $validation_regexp;
        return $this;
    }
    /**
     * Get allowed_values value
     * @return \ArrayType\StringArray|null
     */
    public function getAllowed_values()
    {
        return $this->allowed_values;
    }
    /**
     * Set allowed_values value
     * @param \ArrayType\StringArray $allowed_values
     * @return \StructType\CreditsafeSearchCriteriaParam
     */
    public function setAllowed_values(\ArrayType\StringArray $allowed_values = null)
    {
        $this->allowed_values = $allowed_values;
        return $this;
    }
}
