<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for creditsafeSearchV2RequestType StructType
 * @subpackage Structs
 */
class CreditsafeSearchV2RequestType extends AbstractStructBase
{
    /**
     * The countries
     * @var \ArrayType\StringArray
     */
    public $countries;
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The status
     * @var string
     */
    public $status;
    /**
     * The registration_number
     * @var string
     */
    public $registration_number;
    /**
     * The registration_type
     * @var string
     */
    public $registration_type;
    /**
     * The vat_number
     * @var string
     */
    public $vat_number;
    /**
     * The province
     * @var string
     */
    public $province;
    /**
     * The city
     * @var string
     */
    public $city;
    /**
     * The street
     * @var string
     */
    public $street;
    /**
     * The postal_code
     * @var string
     */
    public $postal_code;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * Constructor method for creditsafeSearchV2RequestType
     * @uses CreditsafeSearchV2RequestType::setCountries()
     * @uses CreditsafeSearchV2RequestType::setId()
     * @uses CreditsafeSearchV2RequestType::setStatus()
     * @uses CreditsafeSearchV2RequestType::setRegistration_number()
     * @uses CreditsafeSearchV2RequestType::setRegistration_type()
     * @uses CreditsafeSearchV2RequestType::setVat_number()
     * @uses CreditsafeSearchV2RequestType::setProvince()
     * @uses CreditsafeSearchV2RequestType::setCity()
     * @uses CreditsafeSearchV2RequestType::setStreet()
     * @uses CreditsafeSearchV2RequestType::setPostal_code()
     * @uses CreditsafeSearchV2RequestType::setName()
     * @param \ArrayType\StringArray $countries
     * @param string $id
     * @param string $status
     * @param string $registration_number
     * @param string $registration_type
     * @param string $vat_number
     * @param string $province
     * @param string $city
     * @param string $street
     * @param string $postal_code
     * @param string $name
     */
    public function __construct(\ArrayType\StringArray $countries = null, $id = null, $status = null, $registration_number = null, $registration_type = null, $vat_number = null, $province = null, $city = null, $street = null, $postal_code = null, $name = null)
    {
        $this
            ->setCountries($countries)
            ->setId($id)
            ->setStatus($status)
            ->setRegistration_number($registration_number)
            ->setRegistration_type($registration_type)
            ->setVat_number($vat_number)
            ->setProvince($province)
            ->setCity($city)
            ->setStreet($street)
            ->setPostal_code($postal_code)
            ->setName($name);
    }
    /**
     * Get countries value
     * @return \ArrayType\StringArray|null
     */
    public function getCountries()
    {
        return $this->countries;
    }
    /**
     * Set countries value
     * @param \ArrayType\StringArray $countries
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setCountries(\ArrayType\StringArray $countries = null)
    {
        $this->countries = $countries;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get registration_number value
     * @return string|null
     */
    public function getRegistration_number()
    {
        return $this->registration_number;
    }
    /**
     * Set registration_number value
     * @param string $registration_number
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setRegistration_number($registration_number = null)
    {
        // validation for constraint: string
        if (!is_null($registration_number) && !is_string($registration_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registration_number, true), gettype($registration_number)), __LINE__);
        }
        $this->registration_number = $registration_number;
        return $this;
    }
    /**
     * Get registration_type value
     * @return string|null
     */
    public function getRegistration_type()
    {
        return $this->registration_type;
    }
    /**
     * Set registration_type value
     * @param string $registration_type
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setRegistration_type($registration_type = null)
    {
        // validation for constraint: string
        if (!is_null($registration_type) && !is_string($registration_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registration_type, true), gettype($registration_type)), __LINE__);
        }
        $this->registration_type = $registration_type;
        return $this;
    }
    /**
     * Get vat_number value
     * @return string|null
     */
    public function getVat_number()
    {
        return $this->vat_number;
    }
    /**
     * Set vat_number value
     * @param string $vat_number
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setVat_number($vat_number = null)
    {
        // validation for constraint: string
        if (!is_null($vat_number) && !is_string($vat_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vat_number, true), gettype($vat_number)), __LINE__);
        }
        $this->vat_number = $vat_number;
        return $this;
    }
    /**
     * Get province value
     * @return string|null
     */
    public function getProvince()
    {
        return $this->province;
    }
    /**
     * Set province value
     * @param string $province
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setProvince($province = null)
    {
        // validation for constraint: string
        if (!is_null($province) && !is_string($province)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($province, true), gettype($province)), __LINE__);
        }
        $this->province = $province;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get street value
     * @return string|null
     */
    public function getStreet()
    {
        return $this->street;
    }
    /**
     * Set street value
     * @param string $street
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setStreet($street = null)
    {
        // validation for constraint: string
        if (!is_null($street) && !is_string($street)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street, true), gettype($street)), __LINE__);
        }
        $this->street = $street;
        return $this;
    }
    /**
     * Get postal_code value
     * @return string|null
     */
    public function getPostal_code()
    {
        return $this->postal_code;
    }
    /**
     * Set postal_code value
     * @param string $postal_code
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setPostal_code($postal_code = null)
    {
        // validation for constraint: string
        if (!is_null($postal_code) && !is_string($postal_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postal_code, true), gettype($postal_code)), __LINE__);
        }
        $this->postal_code = $postal_code;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\CreditsafeSearchV2RequestType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
}
