<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeShareHolder StructType
 * @subpackage Structs
 */
class CreditsafeShareHolder extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $address;
    /**
     * The share_percent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $share_percent;
    /**
     * Constructor method for CreditsafeShareHolder
     * @uses CreditsafeShareHolder::setName()
     * @uses CreditsafeShareHolder::setAddress()
     * @uses CreditsafeShareHolder::setShare_percent()
     * @param string $name
     * @param string $address
     * @param float $share_percent
     */
    public function __construct($name = null, $address = null, $share_percent = null)
    {
        $this
            ->setName($name)
            ->setAddress($address)
            ->setShare_percent($share_percent);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\CreditsafeShareHolder
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param string $address
     * @return \StructType\CreditsafeShareHolder
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address, true), gettype($address)), __LINE__);
        }
        $this->address = $address;
        return $this;
    }
    /**
     * Get share_percent value
     * @return float|null
     */
    public function getShare_percent()
    {
        return $this->share_percent;
    }
    /**
     * Set share_percent value
     * @param float $share_percent
     * @return \StructType\CreditsafeShareHolder
     */
    public function setShare_percent($share_percent = null)
    {
        // validation for constraint: float
        if (!is_null($share_percent) && !(is_float($share_percent) || is_numeric($share_percent))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($share_percent, true), gettype($share_percent)), __LINE__);
        }
        $this->share_percent = $share_percent;
        return $this;
    }
}
