<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessMoneyV3 StructType
 * @subpackage Structs
 */
class DutchBusinessMoneyV3 extends AbstractStructBase
{
    /**
     * The amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $amount;
    /**
     * The currency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $currency;
    /**
     * The formatted
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $formatted;
    /**
     * Constructor method for DutchBusinessMoneyV3
     * @uses DutchBusinessMoneyV3::setAmount()
     * @uses DutchBusinessMoneyV3::setCurrency()
     * @uses DutchBusinessMoneyV3::setFormatted()
     * @param int $amount
     * @param string $currency
     * @param string $formatted
     */
    public function __construct($amount = null, $currency = null, $formatted = null)
    {
        $this
            ->setAmount($amount)
            ->setCurrency($currency)
            ->setFormatted($formatted);
    }
    /**
     * Get amount value
     * @return int|null
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * Set amount value
     * @param int $amount
     * @return \StructType\DutchBusinessMoneyV3
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: int
        if (!is_null($amount) && !(is_int($amount) || ctype_digit($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->amount = $amount;
        return $this;
    }
    /**
     * Get currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->currency;
    }
    /**
     * Set currency value
     * @param string $currency
     * @return \StructType\DutchBusinessMoneyV3
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->currency = $currency;
        return $this;
    }
    /**
     * Get formatted value
     * @return string|null
     */
    public function getFormatted()
    {
        return $this->formatted;
    }
    /**
     * Set formatted value
     * @param string $formatted
     * @return \StructType\DutchBusinessMoneyV3
     */
    public function setFormatted($formatted = null)
    {
        // validation for constraint: string
        if (!is_null($formatted) && !is_string($formatted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($formatted, true), gettype($formatted)), __LINE__);
        }
        $this->formatted = $formatted;
        return $this;
    }
}
