<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessUBOReceipt StructType
 * @subpackage Structs
 */
class DutchBusinessUBOReceipt extends AbstractStructBase
{
    /**
     * The total_price
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $total_price;
    /**
     * The items
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \ArrayType\DutchBusinessUBOReceiptItemArray
     */
    public $items;
    /**
     * Constructor method for DutchBusinessUBOReceipt
     * @uses DutchBusinessUBOReceipt::setTotal_price()
     * @uses DutchBusinessUBOReceipt::setItems()
     * @param string $total_price
     * @param \ArrayType\DutchBusinessUBOReceiptItemArray $items
     */
    public function __construct($total_price = null, \ArrayType\DutchBusinessUBOReceiptItemArray $items = null)
    {
        $this
            ->setTotal_price($total_price)
            ->setItems($items);
    }
    /**
     * Get total_price value
     * @return string
     */
    public function getTotal_price()
    {
        return $this->total_price;
    }
    /**
     * Set total_price value
     * @param string $total_price
     * @return \StructType\DutchBusinessUBOReceipt
     */
    public function setTotal_price($total_price = null)
    {
        // validation for constraint: string
        if (!is_null($total_price) && !is_string($total_price)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($total_price, true), gettype($total_price)), __LINE__);
        }
        $this->total_price = $total_price;
        return $this;
    }
    /**
     * Get items value
     * @return \ArrayType\DutchBusinessUBOReceiptItemArray
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \ArrayType\DutchBusinessUBOReceiptItemArray $items
     * @return \StructType\DutchBusinessUBOReceipt
     */
    public function setItems(\ArrayType\DutchBusinessUBOReceiptItemArray $items = null)
    {
        $this->items = $items;
        return $this;
    }
}
