<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRCalamityOther StructType
 * @subpackage Structs
 */
class GCRCalamityOther extends AbstractStructBase
{
    /**
     * The calamity_code
     * @var int
     */
    public $calamity_code;
    /**
     * The calamity_text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $calamity_text;
    /**
     * The expiration_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $expiration_date;
    /**
     * Constructor method for GCRCalamityOther
     * @uses GCRCalamityOther::setCalamity_code()
     * @uses GCRCalamityOther::setCalamity_text()
     * @uses GCRCalamityOther::setExpiration_date()
     * @param int $calamity_code
     * @param string $calamity_text
     * @param string $expiration_date
     */
    public function __construct($calamity_code = null, $calamity_text = null, $expiration_date = null)
    {
        $this
            ->setCalamity_code($calamity_code)
            ->setCalamity_text($calamity_text)
            ->setExpiration_date($expiration_date);
    }
    /**
     * Get calamity_code value
     * @return int|null
     */
    public function getCalamity_code()
    {
        return $this->calamity_code;
    }
    /**
     * Set calamity_code value
     * @param int $calamity_code
     * @return \StructType\GCRCalamityOther
     */
    public function setCalamity_code($calamity_code = null)
    {
        // validation for constraint: int
        if (!is_null($calamity_code) && !(is_int($calamity_code) || ctype_digit($calamity_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($calamity_code, true), gettype($calamity_code)), __LINE__);
        }
        $this->calamity_code = $calamity_code;
        return $this;
    }
    /**
     * Get calamity_text value
     * @return string|null
     */
    public function getCalamity_text()
    {
        return $this->calamity_text;
    }
    /**
     * Set calamity_text value
     * @param string $calamity_text
     * @return \StructType\GCRCalamityOther
     */
    public function setCalamity_text($calamity_text = null)
    {
        // validation for constraint: string
        if (!is_null($calamity_text) && !is_string($calamity_text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($calamity_text, true), gettype($calamity_text)), __LINE__);
        }
        $this->calamity_text = $calamity_text;
        return $this;
    }
    /**
     * Get expiration_date value
     * @return string|null
     */
    public function getExpiration_date()
    {
        return $this->expiration_date;
    }
    /**
     * Set expiration_date value
     * @param string $expiration_date
     * @return \StructType\GCRCalamityOther
     */
    public function setExpiration_date($expiration_date = null)
    {
        // validation for constraint: string
        if (!is_null($expiration_date) && !is_string($expiration_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiration_date, true), gettype($expiration_date)), __LINE__);
        }
        $this->expiration_date = $expiration_date;
        return $this;
    }
}
