<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRContactDetails StructType
 * @subpackage Structs
 */
class GCRContactDetails extends AbstractStructBase
{
    /**
     * The company_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_name;
    /**
     * The trade_names
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRTradeNameArray
     */
    public $trade_names;
    /**
     * The addresses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRAddressArray
     */
    public $addresses;
    /**
     * The telephone_numbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRTelephoneNumberArray
     */
    public $telephone_numbers;
    /**
     * Constructor method for GCRContactDetails
     * @uses GCRContactDetails::setCompany_name()
     * @uses GCRContactDetails::setTrade_names()
     * @uses GCRContactDetails::setAddresses()
     * @uses GCRContactDetails::setTelephone_numbers()
     * @param string $company_name
     * @param \ArrayType\GCRTradeNameArray $trade_names
     * @param \ArrayType\GCRAddressArray $addresses
     * @param \ArrayType\GCRTelephoneNumberArray $telephone_numbers
     */
    public function __construct($company_name = null, \ArrayType\GCRTradeNameArray $trade_names = null, \ArrayType\GCRAddressArray $addresses = null, \ArrayType\GCRTelephoneNumberArray $telephone_numbers = null)
    {
        $this
            ->setCompany_name($company_name)
            ->setTrade_names($trade_names)
            ->setAddresses($addresses)
            ->setTelephone_numbers($telephone_numbers);
    }
    /**
     * Get company_name value
     * @return string|null
     */
    public function getCompany_name()
    {
        return $this->company_name;
    }
    /**
     * Set company_name value
     * @param string $company_name
     * @return \StructType\GCRContactDetails
     */
    public function setCompany_name($company_name = null)
    {
        // validation for constraint: string
        if (!is_null($company_name) && !is_string($company_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_name, true), gettype($company_name)), __LINE__);
        }
        $this->company_name = $company_name;
        return $this;
    }
    /**
     * Get trade_names value
     * @return \ArrayType\GCRTradeNameArray|null
     */
    public function getTrade_names()
    {
        return $this->trade_names;
    }
    /**
     * Set trade_names value
     * @param \ArrayType\GCRTradeNameArray $trade_names
     * @return \StructType\GCRContactDetails
     */
    public function setTrade_names(\ArrayType\GCRTradeNameArray $trade_names = null)
    {
        $this->trade_names = $trade_names;
        return $this;
    }
    /**
     * Get addresses value
     * @return \ArrayType\GCRAddressArray|null
     */
    public function getAddresses()
    {
        return $this->addresses;
    }
    /**
     * Set addresses value
     * @param \ArrayType\GCRAddressArray $addresses
     * @return \StructType\GCRContactDetails
     */
    public function setAddresses(\ArrayType\GCRAddressArray $addresses = null)
    {
        $this->addresses = $addresses;
        return $this;
    }
    /**
     * Get telephone_numbers value
     * @return \ArrayType\GCRTelephoneNumberArray|null
     */
    public function getTelephone_numbers()
    {
        return $this->telephone_numbers;
    }
    /**
     * Set telephone_numbers value
     * @param \ArrayType\GCRTelephoneNumberArray $telephone_numbers
     * @return \StructType\GCRContactDetails
     */
    public function setTelephone_numbers(\ArrayType\GCRTelephoneNumberArray $telephone_numbers = null)
    {
        $this->telephone_numbers = $telephone_numbers;
        return $this;
    }
}
