<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRContinuation StructType
 * @subpackage Structs
 */
class GCRContinuation extends AbstractStructBase
{
    /**
     * The date_from
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date_from;
    /**
     * The residence
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $residence;
    /**
     * The legal_form_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $legal_form_code;
    /**
     * The legal_form_text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $legal_form_text;
    /**
     * Constructor method for GCRContinuation
     * @uses GCRContinuation::setDate_from()
     * @uses GCRContinuation::setResidence()
     * @uses GCRContinuation::setLegal_form_code()
     * @uses GCRContinuation::setLegal_form_text()
     * @param string $date_from
     * @param string $residence
     * @param int $legal_form_code
     * @param string $legal_form_text
     */
    public function __construct($date_from = null, $residence = null, $legal_form_code = null, $legal_form_text = null)
    {
        $this
            ->setDate_from($date_from)
            ->setResidence($residence)
            ->setLegal_form_code($legal_form_code)
            ->setLegal_form_text($legal_form_text);
    }
    /**
     * Get date_from value
     * @return string|null
     */
    public function getDate_from()
    {
        return $this->date_from;
    }
    /**
     * Set date_from value
     * @param string $date_from
     * @return \StructType\GCRContinuation
     */
    public function setDate_from($date_from = null)
    {
        // validation for constraint: string
        if (!is_null($date_from) && !is_string($date_from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_from, true), gettype($date_from)), __LINE__);
        }
        $this->date_from = $date_from;
        return $this;
    }
    /**
     * Get residence value
     * @return string|null
     */
    public function getResidence()
    {
        return $this->residence;
    }
    /**
     * Set residence value
     * @param string $residence
     * @return \StructType\GCRContinuation
     */
    public function setResidence($residence = null)
    {
        // validation for constraint: string
        if (!is_null($residence) && !is_string($residence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($residence, true), gettype($residence)), __LINE__);
        }
        $this->residence = $residence;
        return $this;
    }
    /**
     * Get legal_form_code value
     * @return int|null
     */
    public function getLegal_form_code()
    {
        return $this->legal_form_code;
    }
    /**
     * Set legal_form_code value
     * @param int $legal_form_code
     * @return \StructType\GCRContinuation
     */
    public function setLegal_form_code($legal_form_code = null)
    {
        // validation for constraint: int
        if (!is_null($legal_form_code) && !(is_int($legal_form_code) || ctype_digit($legal_form_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($legal_form_code, true), gettype($legal_form_code)), __LINE__);
        }
        $this->legal_form_code = $legal_form_code;
        return $this;
    }
    /**
     * Get legal_form_text value
     * @return string|null
     */
    public function getLegal_form_text()
    {
        return $this->legal_form_text;
    }
    /**
     * Set legal_form_text value
     * @param string $legal_form_text
     * @return \StructType\GCRContinuation
     */
    public function setLegal_form_text($legal_form_text = null)
    {
        // validation for constraint: string
        if (!is_null($legal_form_text) && !is_string($legal_form_text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_form_text, true), gettype($legal_form_text)), __LINE__);
        }
        $this->legal_form_text = $legal_form_text;
        return $this;
    }
}
