<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRPersonSimple StructType
 * @subpackage Structs
 */
class GCRPersonSimple extends AbstractStructBase
{
    /**
     * The graydon_person_id
     * @var int
     */
    public $graydon_person_id;
    /**
     * The personal_details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRPersonalDetails
     */
    public $personal_details;
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAddress
     */
    public $address;
    /**
     * The birth_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRBirthInformation
     */
    public $birth_information;
    /**
     * Constructor method for GCRPersonSimple
     * @uses GCRPersonSimple::setGraydon_person_id()
     * @uses GCRPersonSimple::setPersonal_details()
     * @uses GCRPersonSimple::setAddress()
     * @uses GCRPersonSimple::setBirth_information()
     * @param int $graydon_person_id
     * @param \StructType\GCRPersonalDetails $personal_details
     * @param \StructType\GCRAddress $address
     * @param \StructType\GCRBirthInformation $birth_information
     */
    public function __construct($graydon_person_id = null, \StructType\GCRPersonalDetails $personal_details = null, \StructType\GCRAddress $address = null, \StructType\GCRBirthInformation $birth_information = null)
    {
        $this
            ->setGraydon_person_id($graydon_person_id)
            ->setPersonal_details($personal_details)
            ->setAddress($address)
            ->setBirth_information($birth_information);
    }
    /**
     * Get graydon_person_id value
     * @return int|null
     */
    public function getGraydon_person_id()
    {
        return $this->graydon_person_id;
    }
    /**
     * Set graydon_person_id value
     * @param int $graydon_person_id
     * @return \StructType\GCRPersonSimple
     */
    public function setGraydon_person_id($graydon_person_id = null)
    {
        // validation for constraint: int
        if (!is_null($graydon_person_id) && !(is_int($graydon_person_id) || ctype_digit($graydon_person_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($graydon_person_id, true), gettype($graydon_person_id)), __LINE__);
        }
        $this->graydon_person_id = $graydon_person_id;
        return $this;
    }
    /**
     * Get personal_details value
     * @return \StructType\GCRPersonalDetails|null
     */
    public function getPersonal_details()
    {
        return $this->personal_details;
    }
    /**
     * Set personal_details value
     * @param \StructType\GCRPersonalDetails $personal_details
     * @return \StructType\GCRPersonSimple
     */
    public function setPersonal_details(\StructType\GCRPersonalDetails $personal_details = null)
    {
        $this->personal_details = $personal_details;
        return $this;
    }
    /**
     * Get address value
     * @return \StructType\GCRAddress|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\GCRAddress $address
     * @return \StructType\GCRPersonSimple
     */
    public function setAddress(\StructType\GCRAddress $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get birth_information value
     * @return \StructType\GCRBirthInformation|null
     */
    public function getBirth_information()
    {
        return $this->birth_information;
    }
    /**
     * Set birth_information value
     * @param \StructType\GCRBirthInformation $birth_information
     * @return \StructType\GCRPersonSimple
     */
    public function setBirth_information(\StructType\GCRBirthInformation $birth_information = null)
    {
        $this->birth_information = $birth_information;
        return $this;
    }
}
