<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kadasterLocatieBinnenland StructType
 * @subpackage Structs
 */
class KadasterLocatieBinnenland extends AbstractStructBase
{
    /**
     * The plaats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $plaats;
    /**
     * The straatnaam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $straatnaam;
    /**
     * The postcode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postcode;
    /**
     * The huisnummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $huisnummer;
    /**
     * The huisnummer_toevoeging
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $huisnummer_toevoeging;
    /**
     * The huisletter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $huisletter;
    /**
     * The positie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $positie;
    /**
     * Constructor method for kadasterLocatieBinnenland
     * @uses KadasterLocatieBinnenland::setPlaats()
     * @uses KadasterLocatieBinnenland::setStraatnaam()
     * @uses KadasterLocatieBinnenland::setPostcode()
     * @uses KadasterLocatieBinnenland::setHuisnummer()
     * @uses KadasterLocatieBinnenland::setHuisnummer_toevoeging()
     * @uses KadasterLocatieBinnenland::setHuisletter()
     * @uses KadasterLocatieBinnenland::setPositie()
     * @param string $plaats
     * @param string $straatnaam
     * @param string $postcode
     * @param int $huisnummer
     * @param string $huisnummer_toevoeging
     * @param string $huisletter
     * @param string $positie
     */
    public function __construct($plaats = null, $straatnaam = null, $postcode = null, $huisnummer = null, $huisnummer_toevoeging = null, $huisletter = null, $positie = null)
    {
        $this
            ->setPlaats($plaats)
            ->setStraatnaam($straatnaam)
            ->setPostcode($postcode)
            ->setHuisnummer($huisnummer)
            ->setHuisnummer_toevoeging($huisnummer_toevoeging)
            ->setHuisletter($huisletter)
            ->setPositie($positie);
    }
    /**
     * Get plaats value
     * @return string|null
     */
    public function getPlaats()
    {
        return $this->plaats;
    }
    /**
     * Set plaats value
     * @param string $plaats
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setPlaats($plaats = null)
    {
        // validation for constraint: string
        if (!is_null($plaats) && !is_string($plaats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plaats, true), gettype($plaats)), __LINE__);
        }
        $this->plaats = $plaats;
        return $this;
    }
    /**
     * Get straatnaam value
     * @return string|null
     */
    public function getStraatnaam()
    {
        return $this->straatnaam;
    }
    /**
     * Set straatnaam value
     * @param string $straatnaam
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setStraatnaam($straatnaam = null)
    {
        // validation for constraint: string
        if (!is_null($straatnaam) && !is_string($straatnaam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($straatnaam, true), gettype($straatnaam)), __LINE__);
        }
        $this->straatnaam = $straatnaam;
        return $this;
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcode, true), gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get huisnummer value
     * @return int|null
     */
    public function getHuisnummer()
    {
        return $this->huisnummer;
    }
    /**
     * Set huisnummer value
     * @param int $huisnummer
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setHuisnummer($huisnummer = null)
    {
        // validation for constraint: int
        if (!is_null($huisnummer) && !(is_int($huisnummer) || ctype_digit($huisnummer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($huisnummer, true), gettype($huisnummer)), __LINE__);
        }
        $this->huisnummer = $huisnummer;
        return $this;
    }
    /**
     * Get huisnummer_toevoeging value
     * @return string|null
     */
    public function getHuisnummer_toevoeging()
    {
        return $this->huisnummer_toevoeging;
    }
    /**
     * Set huisnummer_toevoeging value
     * @param string $huisnummer_toevoeging
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setHuisnummer_toevoeging($huisnummer_toevoeging = null)
    {
        // validation for constraint: string
        if (!is_null($huisnummer_toevoeging) && !is_string($huisnummer_toevoeging)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($huisnummer_toevoeging, true), gettype($huisnummer_toevoeging)), __LINE__);
        }
        $this->huisnummer_toevoeging = $huisnummer_toevoeging;
        return $this;
    }
    /**
     * Get huisletter value
     * @return string|null
     */
    public function getHuisletter()
    {
        return $this->huisletter;
    }
    /**
     * Set huisletter value
     * @param string $huisletter
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setHuisletter($huisletter = null)
    {
        // validation for constraint: string
        if (!is_null($huisletter) && !is_string($huisletter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($huisletter, true), gettype($huisletter)), __LINE__);
        }
        $this->huisletter = $huisletter;
        return $this;
    }
    /**
     * Get positie value
     * @return string|null
     */
    public function getPositie()
    {
        return $this->positie;
    }
    /**
     * Set positie value
     * @param string $positie
     * @return \StructType\KadasterLocatieBinnenland
     */
    public function setPositie($positie = null)
    {
        // validation for constraint: string
        if (!is_null($positie) && !is_string($positie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($positie, true), gettype($positie)), __LINE__);
        }
        $this->positie = $positie;
        return $this;
    }
}
