<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Hypotheek StructType
 * @subpackage Structs
 */
class KadasterV2Hypotheek extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The omschrijving_betrokken_recht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving_betrokken_recht;
    /**
     * The aandeel_in_betrokken_recht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Breuk
     */
    public $aandeel_in_betrokken_recht;
    /**
     * The onroerende_zaak
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2OnroerendeZaak
     */
    public $onroerende_zaak;
    /**
     * The personen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Personen
     */
    public $personen;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Stukdeel
     */
    public $gebaseerd_op;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $vermeld_in;
    /**
     * Constructor method for KadasterV2Hypotheek
     * @uses KadasterV2Hypotheek::setIdentificatie()
     * @uses KadasterV2Hypotheek::setOmschrijving_betrokken_recht()
     * @uses KadasterV2Hypotheek::setAandeel_in_betrokken_recht()
     * @uses KadasterV2Hypotheek::setOnroerende_zaak()
     * @uses KadasterV2Hypotheek::setPersonen()
     * @uses KadasterV2Hypotheek::setGebaseerd_op()
     * @uses KadasterV2Hypotheek::setVermeld_in()
     * @param string $identificatie
     * @param string $omschrijving_betrokken_recht
     * @param \StructType\KadasterV2Breuk $aandeel_in_betrokken_recht
     * @param \StructType\KadasterV2OnroerendeZaak $onroerende_zaak
     * @param \StructType\KadasterV2Personen $personen
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     */
    public function __construct($identificatie = null, $omschrijving_betrokken_recht = null, \StructType\KadasterV2Breuk $aandeel_in_betrokken_recht = null, \StructType\KadasterV2OnroerendeZaak $onroerende_zaak = null, \StructType\KadasterV2Personen $personen = null, \StructType\KadasterV2Stukdeel $gebaseerd_op = null, \ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setOmschrijving_betrokken_recht($omschrijving_betrokken_recht)
            ->setAandeel_in_betrokken_recht($aandeel_in_betrokken_recht)
            ->setOnroerende_zaak($onroerende_zaak)
            ->setPersonen($personen)
            ->setGebaseerd_op($gebaseerd_op)
            ->setVermeld_in($vermeld_in);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get omschrijving_betrokken_recht value
     * @return string|null
     */
    public function getOmschrijving_betrokken_recht()
    {
        return $this->omschrijving_betrokken_recht;
    }
    /**
     * Set omschrijving_betrokken_recht value
     * @param string $omschrijving_betrokken_recht
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setOmschrijving_betrokken_recht($omschrijving_betrokken_recht = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving_betrokken_recht) && !is_string($omschrijving_betrokken_recht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving_betrokken_recht, true), gettype($omschrijving_betrokken_recht)), __LINE__);
        }
        $this->omschrijving_betrokken_recht = $omschrijving_betrokken_recht;
        return $this;
    }
    /**
     * Get aandeel_in_betrokken_recht value
     * @return \StructType\KadasterV2Breuk|null
     */
    public function getAandeel_in_betrokken_recht()
    {
        return $this->aandeel_in_betrokken_recht;
    }
    /**
     * Set aandeel_in_betrokken_recht value
     * @param \StructType\KadasterV2Breuk $aandeel_in_betrokken_recht
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setAandeel_in_betrokken_recht(\StructType\KadasterV2Breuk $aandeel_in_betrokken_recht = null)
    {
        $this->aandeel_in_betrokken_recht = $aandeel_in_betrokken_recht;
        return $this;
    }
    /**
     * Get onroerende_zaak value
     * @return \StructType\KadasterV2OnroerendeZaak|null
     */
    public function getOnroerende_zaak()
    {
        return $this->onroerende_zaak;
    }
    /**
     * Set onroerende_zaak value
     * @param \StructType\KadasterV2OnroerendeZaak $onroerende_zaak
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setOnroerende_zaak(\StructType\KadasterV2OnroerendeZaak $onroerende_zaak = null)
    {
        $this->onroerende_zaak = $onroerende_zaak;
        return $this;
    }
    /**
     * Get personen value
     * @return \StructType\KadasterV2Personen|null
     */
    public function getPersonen()
    {
        return $this->personen;
    }
    /**
     * Set personen value
     * @param \StructType\KadasterV2Personen $personen
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setPersonen(\StructType\KadasterV2Personen $personen = null)
    {
        $this->personen = $personen;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \StructType\KadasterV2Stukdeel|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setGebaseerd_op(\StructType\KadasterV2Stukdeel $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @return \StructType\KadasterV2Hypotheek
     */
    public function setVermeld_in(\ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
}
