<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2LocatieBuitenland StructType
 * @subpackage Structs
 */
class KadasterV2LocatieBuitenland extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The adres
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $adres;
    /**
     * The adres_regels
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $adres_regels;
    /**
     * The woonplaats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $woonplaats;
    /**
     * The regio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $regio;
    /**
     * The land
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $land;
    /**
     * Constructor method for KadasterV2LocatieBuitenland
     * @uses KadasterV2LocatieBuitenland::setIdentificatie()
     * @uses KadasterV2LocatieBuitenland::setAdres()
     * @uses KadasterV2LocatieBuitenland::setAdres_regels()
     * @uses KadasterV2LocatieBuitenland::setWoonplaats()
     * @uses KadasterV2LocatieBuitenland::setRegio()
     * @uses KadasterV2LocatieBuitenland::setLand()
     * @param string $identificatie
     * @param string $adres
     * @param \ArrayType\StringArray $adres_regels
     * @param string $woonplaats
     * @param string $regio
     * @param string $land
     */
    public function __construct($identificatie = null, $adres = null, \ArrayType\StringArray $adres_regels = null, $woonplaats = null, $regio = null, $land = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAdres($adres)
            ->setAdres_regels($adres_regels)
            ->setWoonplaats($woonplaats)
            ->setRegio($regio)
            ->setLand($land);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get adres value
     * @return string|null
     */
    public function getAdres()
    {
        return $this->adres;
    }
    /**
     * Set adres value
     * @param string $adres
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setAdres($adres = null)
    {
        // validation for constraint: string
        if (!is_null($adres) && !is_string($adres)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adres, true), gettype($adres)), __LINE__);
        }
        $this->adres = $adres;
        return $this;
    }
    /**
     * Get adres_regels value
     * @return \ArrayType\StringArray|null
     */
    public function getAdres_regels()
    {
        return $this->adres_regels;
    }
    /**
     * Set adres_regels value
     * @param \ArrayType\StringArray $adres_regels
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setAdres_regels(\ArrayType\StringArray $adres_regels = null)
    {
        $this->adres_regels = $adres_regels;
        return $this;
    }
    /**
     * Get woonplaats value
     * @return string|null
     */
    public function getWoonplaats()
    {
        return $this->woonplaats;
    }
    /**
     * Set woonplaats value
     * @param string $woonplaats
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setWoonplaats($woonplaats = null)
    {
        // validation for constraint: string
        if (!is_null($woonplaats) && !is_string($woonplaats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($woonplaats, true), gettype($woonplaats)), __LINE__);
        }
        $this->woonplaats = $woonplaats;
        return $this;
    }
    /**
     * Get regio value
     * @return string|null
     */
    public function getRegio()
    {
        return $this->regio;
    }
    /**
     * Set regio value
     * @param string $regio
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setRegio($regio = null)
    {
        // validation for constraint: string
        if (!is_null($regio) && !is_string($regio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($regio, true), gettype($regio)), __LINE__);
        }
        $this->regio = $regio;
        return $this;
    }
    /**
     * Get land value
     * @return string|null
     */
    public function getLand()
    {
        return $this->land;
    }
    /**
     * Set land value
     * @param string $land
     * @return \StructType\KadasterV2LocatieBuitenland
     */
    public function setLand($land = null)
    {
        // validation for constraint: string
        if (!is_null($land) && !is_string($land)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($land, true), gettype($land)), __LINE__);
        }
        $this->land = $land;
        return $this;
    }
}
