<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2OnroerendeZaakFiliatie StructType
 * @subpackage Structs
 */
class KadasterV2OnroerendeZaakFiliatie extends AbstractStructBase
{
    /**
     * The aard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $aard;
    /**
     * The overgangsgrootte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $overgangsgrootte;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2OnroerendeZaakReferenceArray
     */
    public $betreft;
    /**
     * Constructor method for KadasterV2OnroerendeZaakFiliatie
     * @uses KadasterV2OnroerendeZaakFiliatie::setAard()
     * @uses KadasterV2OnroerendeZaakFiliatie::setOvergangsgrootte()
     * @uses KadasterV2OnroerendeZaakFiliatie::setBetreft()
     * @param string $aard
     * @param float $overgangsgrootte
     * @param \ArrayType\KadasterV2OnroerendeZaakReferenceArray $betreft
     */
    public function __construct($aard = null, $overgangsgrootte = null, \ArrayType\KadasterV2OnroerendeZaakReferenceArray $betreft = null)
    {
        $this
            ->setAard($aard)
            ->setOvergangsgrootte($overgangsgrootte)
            ->setBetreft($betreft);
    }
    /**
     * Get aard value
     * @return string|null
     */
    public function getAard()
    {
        return $this->aard;
    }
    /**
     * Set aard value
     * @param string $aard
     * @return \StructType\KadasterV2OnroerendeZaakFiliatie
     */
    public function setAard($aard = null)
    {
        // validation for constraint: string
        if (!is_null($aard) && !is_string($aard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard, true), gettype($aard)), __LINE__);
        }
        $this->aard = $aard;
        return $this;
    }
    /**
     * Get overgangsgrootte value
     * @return float|null
     */
    public function getOvergangsgrootte()
    {
        return $this->overgangsgrootte;
    }
    /**
     * Set overgangsgrootte value
     * @param float $overgangsgrootte
     * @return \StructType\KadasterV2OnroerendeZaakFiliatie
     */
    public function setOvergangsgrootte($overgangsgrootte = null)
    {
        // validation for constraint: float
        if (!is_null($overgangsgrootte) && !(is_float($overgangsgrootte) || is_numeric($overgangsgrootte))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($overgangsgrootte, true), gettype($overgangsgrootte)), __LINE__);
        }
        $this->overgangsgrootte = $overgangsgrootte;
        return $this;
    }
    /**
     * Get betreft value
     * @return \ArrayType\KadasterV2OnroerendeZaakReferenceArray|null
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \ArrayType\KadasterV2OnroerendeZaakReferenceArray $betreft
     * @return \StructType\KadasterV2OnroerendeZaakFiliatie
     */
    public function setBetreft(\ArrayType\KadasterV2OnroerendeZaakReferenceArray $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
}
