<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KvkUpdateReference StructType
 * @subpackage Structs
 */
class KvkUpdateReference extends AbstractStructBase
{
    /**
     * The dossier_number
     * @var string
     */
    public $dossier_number;
    /**
     * The establishment_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $establishment_number;
    /**
     * The update_types
     * @var \ArrayType\StringArray
     */
    public $update_types;
    /**
     * The date_last_update
     * @var string
     */
    public $date_last_update;
    /**
     * Constructor method for KvkUpdateReference
     * @uses KvkUpdateReference::setDossier_number()
     * @uses KvkUpdateReference::setEstablishment_number()
     * @uses KvkUpdateReference::setUpdate_types()
     * @uses KvkUpdateReference::setDate_last_update()
     * @param string $dossier_number
     * @param string $establishment_number
     * @param \ArrayType\StringArray $update_types
     * @param string $date_last_update
     */
    public function __construct($dossier_number = null, $establishment_number = null, \ArrayType\StringArray $update_types = null, $date_last_update = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setEstablishment_number($establishment_number)
            ->setUpdate_types($update_types)
            ->setDate_last_update($date_last_update);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\KvkUpdateReference
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get establishment_number value
     * @return string|null
     */
    public function getEstablishment_number()
    {
        return $this->establishment_number;
    }
    /**
     * Set establishment_number value
     * @param string $establishment_number
     * @return \StructType\KvkUpdateReference
     */
    public function setEstablishment_number($establishment_number = null)
    {
        // validation for constraint: string
        if (!is_null($establishment_number) && !is_string($establishment_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($establishment_number, true), gettype($establishment_number)), __LINE__);
        }
        $this->establishment_number = $establishment_number;
        return $this;
    }
    /**
     * Get update_types value
     * @return \ArrayType\StringArray|null
     */
    public function getUpdate_types()
    {
        return $this->update_types;
    }
    /**
     * Set update_types value
     * @param \ArrayType\StringArray $update_types
     * @return \StructType\KvkUpdateReference
     */
    public function setUpdate_types(\ArrayType\StringArray $update_types = null)
    {
        $this->update_types = $update_types;
        return $this;
    }
    /**
     * Get date_last_update value
     * @return string|null
     */
    public function getDate_last_update()
    {
        return $this->date_last_update;
    }
    /**
     * Set date_last_update value
     * @param string $date_last_update
     * @return \StructType\KvkUpdateReference
     */
    public function setDate_last_update($date_last_update = null)
    {
        // validation for constraint: string
        if (!is_null($date_last_update) && !is_string($date_last_update)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_last_update, true), gettype($date_last_update)), __LINE__);
        }
        $this->date_last_update = $date_last_update;
        return $this;
    }
}
