<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RiskPersonCompanyReport StructType
 * @subpackage Structs
 */
class RiskPersonCompanyReport extends AbstractStructBase
{
    /**
     * The person
     * @var \StructType\RiskPerson
     */
    public $person;
    /**
     * The conclusion
     * @var \StructType\RiskResult
     */
    public $conclusion;
    /**
     * The report_data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RiskCompanyReport
     */
    public $report_data;
    /**
     * Constructor method for RiskPersonCompanyReport
     * @uses RiskPersonCompanyReport::setPerson()
     * @uses RiskPersonCompanyReport::setConclusion()
     * @uses RiskPersonCompanyReport::setReport_data()
     * @param \StructType\RiskPerson $person
     * @param \StructType\RiskResult $conclusion
     * @param \StructType\RiskCompanyReport $report_data
     */
    public function __construct(\StructType\RiskPerson $person = null, \StructType\RiskResult $conclusion = null, \StructType\RiskCompanyReport $report_data = null)
    {
        $this
            ->setPerson($person)
            ->setConclusion($conclusion)
            ->setReport_data($report_data);
    }
    /**
     * Get person value
     * @return \StructType\RiskPerson|null
     */
    public function getPerson()
    {
        return $this->person;
    }
    /**
     * Set person value
     * @param \StructType\RiskPerson $person
     * @return \StructType\RiskPersonCompanyReport
     */
    public function setPerson(\StructType\RiskPerson $person = null)
    {
        $this->person = $person;
        return $this;
    }
    /**
     * Get conclusion value
     * @return \StructType\RiskResult|null
     */
    public function getConclusion()
    {
        return $this->conclusion;
    }
    /**
     * Set conclusion value
     * @param \StructType\RiskResult $conclusion
     * @return \StructType\RiskPersonCompanyReport
     */
    public function setConclusion(\StructType\RiskResult $conclusion = null)
    {
        $this->conclusion = $conclusion;
        return $this;
    }
    /**
     * Get report_data value
     * @return \StructType\RiskCompanyReport|null
     */
    public function getReport_data()
    {
        return $this->report_data;
    }
    /**
     * Set report_data value
     * @param \StructType\RiskCompanyReport $report_data
     * @return \StructType\RiskPersonCompanyReport
     */
    public function setReport_data(\StructType\RiskCompanyReport $report_data = null)
    {
        $this->report_data = $report_data;
        return $this;
    }
}
