<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SepaIbanDetails StructType
 * @subpackage Structs
 */
class SepaIbanDetails extends AbstractStructBase
{
    /**
     * The check_digits
     * @var string
     */
    public $check_digits;
    /**
     * The country_code
     * @var string
     */
    public $country_code;
    /**
     * The bban
     * @var string
     */
    public $bban;
    /**
     * The bban_details
     * @var \StructType\BbanDetails
     */
    public $bban_details;
    /**
     * Constructor method for SepaIbanDetails
     * @uses SepaIbanDetails::setCheck_digits()
     * @uses SepaIbanDetails::setCountry_code()
     * @uses SepaIbanDetails::setBban()
     * @uses SepaIbanDetails::setBban_details()
     * @param string $check_digits
     * @param string $country_code
     * @param string $bban
     * @param \StructType\BbanDetails $bban_details
     */
    public function __construct($check_digits = null, $country_code = null, $bban = null, \StructType\BbanDetails $bban_details = null)
    {
        $this
            ->setCheck_digits($check_digits)
            ->setCountry_code($country_code)
            ->setBban($bban)
            ->setBban_details($bban_details);
    }
    /**
     * Get check_digits value
     * @return string|null
     */
    public function getCheck_digits()
    {
        return $this->check_digits;
    }
    /**
     * Set check_digits value
     * @param string $check_digits
     * @return \StructType\SepaIbanDetails
     */
    public function setCheck_digits($check_digits = null)
    {
        // validation for constraint: string
        if (!is_null($check_digits) && !is_string($check_digits)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($check_digits, true), gettype($check_digits)), __LINE__);
        }
        $this->check_digits = $check_digits;
        return $this;
    }
    /**
     * Get country_code value
     * @return string|null
     */
    public function getCountry_code()
    {
        return $this->country_code;
    }
    /**
     * Set country_code value
     * @param string $country_code
     * @return \StructType\SepaIbanDetails
     */
    public function setCountry_code($country_code = null)
    {
        // validation for constraint: string
        if (!is_null($country_code) && !is_string($country_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country_code, true), gettype($country_code)), __LINE__);
        }
        $this->country_code = $country_code;
        return $this;
    }
    /**
     * Get bban value
     * @return string|null
     */
    public function getBban()
    {
        return $this->bban;
    }
    /**
     * Set bban value
     * @param string $bban
     * @return \StructType\SepaIbanDetails
     */
    public function setBban($bban = null)
    {
        // validation for constraint: string
        if (!is_null($bban) && !is_string($bban)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bban, true), gettype($bban)), __LINE__);
        }
        $this->bban = $bban;
        return $this;
    }
    /**
     * Get bban_details value
     * @return \StructType\BbanDetails|null
     */
    public function getBban_details()
    {
        return $this->bban_details;
    }
    /**
     * Set bban_details value
     * @param \StructType\BbanDetails $bban_details
     * @return \StructType\SepaIbanDetails
     */
    public function setBban_details(\StructType\BbanDetails $bban_details = null)
    {
        $this->bban_details = $bban_details;
        return $this;
    }
}
