<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SepaMatchBankAccountDetails StructType
 * @subpackage Structs
 */
class SepaMatchBankAccountDetails extends AbstractStructBase
{
    /**
     * The foreign
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $foreign;
    /**
     * The country_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country_code;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * Constructor method for SepaMatchBankAccountDetails
     * @uses SepaMatchBankAccountDetails::setForeign()
     * @uses SepaMatchBankAccountDetails::setCountry_code()
     * @uses SepaMatchBankAccountDetails::setStatus()
     * @param bool $foreign
     * @param string $country_code
     * @param string $status
     */
    public function __construct($foreign = null, $country_code = null, $status = null)
    {
        $this
            ->setForeign($foreign)
            ->setCountry_code($country_code)
            ->setStatus($status);
    }
    /**
     * Get foreign value
     * @return bool|null
     */
    public function getForeign()
    {
        return $this->foreign;
    }
    /**
     * Set foreign value
     * @param bool $foreign
     * @return \StructType\SepaMatchBankAccountDetails
     */
    public function setForeign($foreign = null)
    {
        // validation for constraint: boolean
        if (!is_null($foreign) && !is_bool($foreign)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($foreign, true), gettype($foreign)), __LINE__);
        }
        $this->foreign = $foreign;
        return $this;
    }
    /**
     * Get country_code value
     * @return string|null
     */
    public function getCountry_code()
    {
        return $this->country_code;
    }
    /**
     * Set country_code value
     * @param string $country_code
     * @return \StructType\SepaMatchBankAccountDetails
     */
    public function setCountry_code($country_code = null)
    {
        // validation for constraint: string
        if (!is_null($country_code) && !is_string($country_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country_code, true), gettype($country_code)), __LINE__);
        }
        $this->country_code = $country_code;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\SepaMatchBankAccountDetails
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
}
