<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SessionPagedResult StructType
 * @subpackage Structs
 */
class SessionPagedResult extends AbstractStructBase
{
    /**
     * The paging
     * @var \StructType\ResultInfo
     */
    public $paging;
    /**
     * The results
     * @var \ArrayType\SessionArray
     */
    public $results;
    /**
     * Constructor method for SessionPagedResult
     * @uses SessionPagedResult::setPaging()
     * @uses SessionPagedResult::setResults()
     * @param \StructType\ResultInfo $paging
     * @param \ArrayType\SessionArray $results
     */
    public function __construct(\StructType\ResultInfo $paging = null, \ArrayType\SessionArray $results = null)
    {
        $this
            ->setPaging($paging)
            ->setResults($results);
    }
    /**
     * Get paging value
     * @return \StructType\ResultInfo|null
     */
    public function getPaging()
    {
        return $this->paging;
    }
    /**
     * Set paging value
     * @param \StructType\ResultInfo $paging
     * @return \StructType\SessionPagedResult
     */
    public function setPaging(\StructType\ResultInfo $paging = null)
    {
        $this->paging = $paging;
        return $this;
    }
    /**
     * Get results value
     * @return \ArrayType\SessionArray|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \ArrayType\SessionArray $results
     * @return \StructType\SessionPagedResult
     */
    public function setResults(\ArrayType\SessionArray $results = null)
    {
        $this->results = $results;
        return $this;
    }
}
